c  Interpolates high frequency GPS data
c
      character*20 ifile,ofile
      double precision fjul,time,time0,day(20000000),sum_short,
     &  sum2_short,tsam_day,t_last
      dimension d(20000000),e(20000000),ran(1)
      integer year(20000000)
      nmax=20000000
      nr=1

      fmiss=9999999.
      print*,' Input file to examine'
      print*,'   input format is year, julian day, data, data_error'
      read(5,100)ifile
100   format(a20)
      open(1,file=ifile)
      print*,' Input name of output file'
      read(5,100)ofile
      open(4,file=ofile)
      open(7,file="gap.dat")
      print*,' Input sampling interval in days'
      print*,'   1--hour = ',1./24.d+0
      print*,'   10--minutes =',10./(24.d+0 * 60.0d+0)
      print*,'   1--minute = ',1.0/(24.d+0 * 60.0d+0)
      print*,'   30--second = ',30.0/(24.d+0 * 3600.0d+0)
      print*,'   1--second =', 1.0/(24.d+0 * 3600.0d+0)
      read(5,*)tsam_day
c   set maximum gap in data to be 5 minutes
      gap_max=(5./(24.*60))
      max_gap=int(gap_max/tsam_day)
c
c  input the data 
c
      dt_time_min=9999999.
      t_last=0.
      do 1 i=1,nmax
1     d(i)=fmiss
      n=0
      ic=0
      iseed=0
2     continue
      read(1,*,end=3)yr,fjul,obs,err

        call jul2day(int(yr+0.5),int(fjul+0.5),iday)


        time=float(iday)+fjul-float(int(fjul+0.5))
        if (n .eq. 0) time0=time
        n=int(((time-time0)/tsam_day)+0.5)+1

        ic=ic+1
        year(n)=yr
        day(n)=fjul
        d(n)=obs
        e(n)=err
        if (time-t_last .lt. dt_time_min) then
            dt_time_min=time-t_last
            n_min=ic
        end if
        t_last=time
c  create a seed from input data
        if (ic .lt. 7) then
           iobs=int(abs(obs))
           decimal=abs(obs)-float(iobs)
           idec=int(10.*decimal +0.5 )
           iseed=idec*(10**(ic-1)) + iseed
c           print*,ic,obs,iobs,idec,iseed
        end if

      go to 2
3     continue
      print*,' Number of observation is ',ic
      print*,' Total number of days ',n*tsam_day
      print*,'  smallest sampling interval read is ',dt_time_min,' day'
      print*,'     at point number ',n_min
c
c  determine the short period standard deviation of the data
c   using first differences
c
      sum_short=0.0
      sum2_short=0.0
      nshort=0
      do 5 i=2,n
        if ((d(i) .ne. fmiss) .and. (d(i-1) .ne. fmiss)) then
        delta=d(i)-d(i-1)
        nshort=nshort+1
        sum_short=sum_short+delta
        sum2_short=sum2_short+delta**2
        end if
5     continue
      ave_rate=sum_short/float(nshort)
      print*,' Average rate based upon first difference',ave_rate,
     & ' units/(sampling interval)'
      sd_short=sqrt((sum2_short - float(nshort)*(ave_rate**2))
     &  /(2.0*float(nshort)))
      print*,' Standard deviation based upon first differences',
     & sd_short
c      print*,nshort,sum_short,sum2_short
c
c  fill in missing data using above short-term standard deviation
c
      nreal=0
      niter=0
      i=1
10    continue
      if (i .le. n) then
        if (d(i) .ne. fmiss) then
           write(4,110)year(i),day(i),d(i),e(i)
           nreal=nreal+1
           ilast=i
           dlast=d(i)
110        format(i6,f20.9,f12.3,1x,f4.1)
        else
c  missing datum identified
c
c   look ahead for next measurement
          ix=i+1
15        continue
          if (d(ix) .eq. fmiss) then
             ix=ix+1
             go to 15
          else
c    next measurment is found!
            dbar=(dlast+d(ix))/2
            sl=(d(ix)-dlast)/float(ix-ilast)
            do 20 j=i,ix-1
              d(j)=dlast+sl*float(j-ilast)
              call gaus(ran,1,iseed)
c              print*,iseed,ran(1)
              d(j)=d(j)+ran(1)*sd_short
              time=float(j-1)*tsam_day+time0
              itime=int(time+0.3)
              call inv_jul_time(itime,nyr,jul)
              time=float(jul)+time-float(itime)
 
              write(4,110)nyr,time,d(j),0.1
c             ,j,dlast,d(ix),
c     &         sl,j-ilast,ix,ilast,ix-ilast
              niter=niter+1
c111           format(i6,f20.9,f20.1,f8.1,i7,2f8.1,f10.4,4i8)
20          continue
            igap=ix-i

            if (igap .ge. max_gap) then
              write(7,112)igap,max_gap, year(ix),day(ix)
112           format(i10,' gap in data exceeds ',i5,
     &            ' points before ',i5,f20.9)
            end if
            write(4,110)year(ix),day(ix),d(ix),e(ix)
            nreal=nreal+1
            i=ix
          end if
     


        end if
        i=i+1
        go to 10
      end if
      print*,' Number of data read',nreal
      print*,' Number of data interpolated',niter
      close (1)
      close (4)
      close (7)
      print*,' Interpolated data in ',ofile
      print*,' List is significant data gaps in gap.dat'
      stop
      end
      subroutine jul2day(yr,jul,iday)
      integer yr, jul, iday
      yr=yr-1900
      iday=0
      if (yr .gt. 60 ) iday=iday+1
      if (yr .gt. 64 ) iday=iday+1
      if (yr .gt. 68 ) iday=iday+1
      if (yr .gt. 72 ) iday=iday+1
      if (yr .gt. 76 ) iday=iday+1
      if (yr .gt. 80 ) iday=iday+1
      if (yr .gt. 84 ) iday=iday+1
      if (yr .gt. 88 ) iday=iday+1
      if (yr .gt. 92 ) iday=iday+1
      if (yr .gt. 96 ) iday=iday+1
      if (yr .gt. 100 ) iday=iday+1
      if (yr .gt. 104 ) iday=iday+1
      if (yr .gt. 108 ) iday=iday+1

      iday=iday+(yr-60)*365 + jul
      yr=yr+1900
      return
      end
      subroutine inv_jul_time(itime,nyr,jul)
c converts day number since jan 1, 1960 back to julian day and year
c
c  itime is number of days since Jan 1, 1960
      dimension nyear(60),nleap(60)
      nx=60
        do 1 i=1,nx
        nleap(i)=1+(i-1)*4
1       continue
        j=1
        ncnt=0
        do 2 i=1,nx
        if (i .eq. nleap(j)) then
           ncnt=ncnt+366
           j=j+1
        else
          ncnt=ncnt+365
        end if
        nyear(i)=ncnt
c        print*,i,nyear(i)
2       continue
      k=1
      nyr=1960
c      if (itime .lt. nyear(1)) then
      if (itime .le. nyear(1)) then
        jul=itime
        return
      end if
      k=2
      nyr=nyr+1
3     continue
      if ((itime .gt. nyear(k-1)) .and. (itime .le. nyear(k))) then
        jul=itime-nyear(k-1)
        return
      else
        k=k+1
        nyr=nyr+1
        go to 3
      end if
      end
      subroutine gaus(x,nd,ir)
c  program creates white noise with a gausian distribution with
c  variance=1 and mean equal to zero
c  x are an array of random numbers
c  nd is the length of the array
c  ir is the seed for the random number generator
      dimension x(1)
      if (ir .gt. 0) ir=-1*ir
      do 1 i=1,nd
      x(i)=gasdev(ir)
1     continue
      return
      end
      FUNCTION GASDEV(IDUM)
c From Numerical Recipes; 1992
      SAVE ISET,GSET
      DATA ISET/0/
      IF (ISET.EQ.0) THEN
1       V1=2.*RAN1(IDUM)-1.
        V2=2.*RAN1(IDUM)-1.
        R=V1**2+V2**2
        IF(R.GE.1. .or. r .eq. 0)GO TO 1
        FAC=SQRT(-2.*LOG(R)/R)
        GSET=V1*FAC
        GASDEV=V2*FAC
        ISET=1
      ELSE
        GASDEV=GSET
        ISET=0
      ENDIF
      RETURN
      END
      FUNCTION RAN1(IDUM)
c From Numerical Recipes; 1992
c idum must be less than zero to initialize
      integer idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     &   NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-07,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum .le. 0 .or. iy .eq. 0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum .lt. 0) idum=idum+IM
          if (j .le. NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum .lt. 0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      end


